/*!
This is the header file for the MyEventSegment class, designed 
to read out a LeCroy 4300B FERA ADC.  

Tim Hoagland
1/19/05
s04.thoagland@wittenberg.edu
*/

#ifndef __MYEVENTSEGMENT_H
#define __MTEVENTSEGMENT_H
#include <spectrodaq.h>
#include <CEventSegment.h>
#include <CDocumentedPacket.h>
#include <camac.h>



// Declares a class derived from CEventSegment
class MyEventSegment : public CEventSegment   
{
private:
  CDocumentedPacket m_MyPacket; 
  unsigned int Tag;      // Packet ID Tag
  unsigned int Slot;     // CAMAC slot module is in
  unsigned int Branch;   // CAMAC Branch #
  unsigned int Crate;    // CAMAC crate #
public:
  MyEventSegment(unsigned short tag, int slot, int branch, int crate);
              // Defines packet info, sets private variables

  virtual void Initialize();                    
             // One time Module setup

  virtual void Clear();            
             // Resets data buffer

  virtual unsigned int MaxSize();               

  virtual DAQWordBufferPtr& Read(DAQWordBufferPtr& bufpt);  
             // Reads data buffer
};
#endif

