/*!
This is the header file for MyEventProcessor.  It is
intended to be used to decode a packet from a 
LeCroy 4300B FERA ADC.

Tim Hoagland
1/19/05
s04.thoagland@wittenberg.edu
*/

#ifndef __MYEVENTPROCESSOR_H
#define __MYEVENTPROCESSOR_H
#include <EventProcessor.h>
#include <TranslatorPointer.h>
#include <BufferDecoder.h>
#include <Analyzer.h>
#include <TCLApplication.h>
#include <Event.h>

class MyEventProcessor : public CEventProcessor
{
 private:
  int Base;        //base slot for data
  int nOurId;      //ID tag to unpack


 public:
  // Tests if a given packets Id = nOurId
  virtual Bool_t operator()(const Address_t pEvent, CEvent& rEvent,
			    CAnalyzer& rAnalyzer, CBufferDecoder& rDecoder);

  // constuctor
  MyEventProcessor(int base, int Id);


 protected:
  // unpacks and stores packet information in rBuf
  void UnpackPacket(TranslatorPointer<UShort_t>p, CEvent& rEvent);
};
#endif
